/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the DocumentSshConfigTrait type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &DocumentSshConfigTrait{}

// DocumentSshConfigTrait struct for DocumentSshConfigTrait
type DocumentSshConfigTrait struct {
	Host          *string        `json:"host,omitempty"`
	Port          *int32         `json:"port,omitempty"`
	Username      *string        `json:"username,omitempty"`
	Password      NullableString `json:"password,omitempty"`
	CertificateId NullableString `json:"certificateId,omitempty"`
	RemoteHost    NullableString `json:"remoteHost,omitempty"`
	RemotePort    NullableInt32  `json:"remotePort,omitempty"`
}

// NewDocumentSshConfigTrait instantiates a new DocumentSshConfigTrait object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewDocumentSshConfigTrait() *DocumentSshConfigTrait {
	this := DocumentSshConfigTrait{}
	return &this
}

// NewDocumentSshConfigTraitWithDefaults instantiates a new DocumentSshConfigTrait object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewDocumentSshConfigTraitWithDefaults() *DocumentSshConfigTrait {
	this := DocumentSshConfigTrait{}
	return &this
}

// GetHost returns the Host field value if set, zero value otherwise.
func (o *DocumentSshConfigTrait) GetHost() string {
	if o == nil || IsNil(o.Host) {
		var ret string
		return ret
	}
	return *o.Host
}

// GetHostOk returns a tuple with the Host field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DocumentSshConfigTrait) GetHostOk() (*string, bool) {
	if o == nil || IsNil(o.Host) {
		return nil, false
	}
	return o.Host, true
}

// HasHost returns a boolean if a field has been set.
func (o *DocumentSshConfigTrait) HasHost() bool {
	if o != nil && !IsNil(o.Host) {
		return true
	}

	return false
}

// SetHost gets a reference to the given string and assigns it to the Host field.
func (o *DocumentSshConfigTrait) SetHost(v string) {
	o.Host = &v
}

// GetPort returns the Port field value if set, zero value otherwise.
func (o *DocumentSshConfigTrait) GetPort() int32 {
	if o == nil || IsNil(o.Port) {
		var ret int32
		return ret
	}
	return *o.Port
}

// GetPortOk returns a tuple with the Port field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DocumentSshConfigTrait) GetPortOk() (*int32, bool) {
	if o == nil || IsNil(o.Port) {
		return nil, false
	}
	return o.Port, true
}

// HasPort returns a boolean if a field has been set.
func (o *DocumentSshConfigTrait) HasPort() bool {
	if o != nil && !IsNil(o.Port) {
		return true
	}

	return false
}

// SetPort gets a reference to the given int32 and assigns it to the Port field.
func (o *DocumentSshConfigTrait) SetPort(v int32) {
	o.Port = &v
}

// GetUsername returns the Username field value if set, zero value otherwise.
func (o *DocumentSshConfigTrait) GetUsername() string {
	if o == nil || IsNil(o.Username) {
		var ret string
		return ret
	}
	return *o.Username
}

// GetUsernameOk returns a tuple with the Username field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DocumentSshConfigTrait) GetUsernameOk() (*string, bool) {
	if o == nil || IsNil(o.Username) {
		return nil, false
	}
	return o.Username, true
}

// HasUsername returns a boolean if a field has been set.
func (o *DocumentSshConfigTrait) HasUsername() bool {
	if o != nil && !IsNil(o.Username) {
		return true
	}

	return false
}

// SetUsername gets a reference to the given string and assigns it to the Username field.
func (o *DocumentSshConfigTrait) SetUsername(v string) {
	o.Username = &v
}

// GetPassword returns the Password field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *DocumentSshConfigTrait) GetPassword() string {
	if o == nil || IsNil(o.Password.Get()) {
		var ret string
		return ret
	}
	return *o.Password.Get()
}

// GetPasswordOk returns a tuple with the Password field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *DocumentSshConfigTrait) GetPasswordOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Password.Get(), o.Password.IsSet()
}

// HasPassword returns a boolean if a field has been set.
func (o *DocumentSshConfigTrait) HasPassword() bool {
	if o != nil && o.Password.IsSet() {
		return true
	}

	return false
}

// SetPassword gets a reference to the given NullableString and assigns it to the Password field.
func (o *DocumentSshConfigTrait) SetPassword(v string) {
	o.Password.Set(&v)
}

// SetPasswordNil sets the value for Password to be an explicit nil
func (o *DocumentSshConfigTrait) SetPasswordNil() {
	o.Password.Set(nil)
}

// UnsetPassword ensures that no value is present for Password, not even an explicit nil
func (o *DocumentSshConfigTrait) UnsetPassword() {
	o.Password.Unset()
}

// GetCertificateId returns the CertificateId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *DocumentSshConfigTrait) GetCertificateId() string {
	if o == nil || IsNil(o.CertificateId.Get()) {
		var ret string
		return ret
	}
	return *o.CertificateId.Get()
}

// GetCertificateIdOk returns a tuple with the CertificateId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *DocumentSshConfigTrait) GetCertificateIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.CertificateId.Get(), o.CertificateId.IsSet()
}

// HasCertificateId returns a boolean if a field has been set.
func (o *DocumentSshConfigTrait) HasCertificateId() bool {
	if o != nil && o.CertificateId.IsSet() {
		return true
	}

	return false
}

// SetCertificateId gets a reference to the given NullableString and assigns it to the CertificateId field.
func (o *DocumentSshConfigTrait) SetCertificateId(v string) {
	o.CertificateId.Set(&v)
}

// SetCertificateIdNil sets the value for CertificateId to be an explicit nil
func (o *DocumentSshConfigTrait) SetCertificateIdNil() {
	o.CertificateId.Set(nil)
}

// UnsetCertificateId ensures that no value is present for CertificateId, not even an explicit nil
func (o *DocumentSshConfigTrait) UnsetCertificateId() {
	o.CertificateId.Unset()
}

// GetRemoteHost returns the RemoteHost field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *DocumentSshConfigTrait) GetRemoteHost() string {
	if o == nil || IsNil(o.RemoteHost.Get()) {
		var ret string
		return ret
	}
	return *o.RemoteHost.Get()
}

// GetRemoteHostOk returns a tuple with the RemoteHost field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *DocumentSshConfigTrait) GetRemoteHostOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.RemoteHost.Get(), o.RemoteHost.IsSet()
}

// HasRemoteHost returns a boolean if a field has been set.
func (o *DocumentSshConfigTrait) HasRemoteHost() bool {
	if o != nil && o.RemoteHost.IsSet() {
		return true
	}

	return false
}

// SetRemoteHost gets a reference to the given NullableString and assigns it to the RemoteHost field.
func (o *DocumentSshConfigTrait) SetRemoteHost(v string) {
	o.RemoteHost.Set(&v)
}

// SetRemoteHostNil sets the value for RemoteHost to be an explicit nil
func (o *DocumentSshConfigTrait) SetRemoteHostNil() {
	o.RemoteHost.Set(nil)
}

// UnsetRemoteHost ensures that no value is present for RemoteHost, not even an explicit nil
func (o *DocumentSshConfigTrait) UnsetRemoteHost() {
	o.RemoteHost.Unset()
}

// GetRemotePort returns the RemotePort field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *DocumentSshConfigTrait) GetRemotePort() int32 {
	if o == nil || IsNil(o.RemotePort.Get()) {
		var ret int32
		return ret
	}
	return *o.RemotePort.Get()
}

// GetRemotePortOk returns a tuple with the RemotePort field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *DocumentSshConfigTrait) GetRemotePortOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.RemotePort.Get(), o.RemotePort.IsSet()
}

// HasRemotePort returns a boolean if a field has been set.
func (o *DocumentSshConfigTrait) HasRemotePort() bool {
	if o != nil && o.RemotePort.IsSet() {
		return true
	}

	return false
}

// SetRemotePort gets a reference to the given NullableInt32 and assigns it to the RemotePort field.
func (o *DocumentSshConfigTrait) SetRemotePort(v int32) {
	o.RemotePort.Set(&v)
}

// SetRemotePortNil sets the value for RemotePort to be an explicit nil
func (o *DocumentSshConfigTrait) SetRemotePortNil() {
	o.RemotePort.Set(nil)
}

// UnsetRemotePort ensures that no value is present for RemotePort, not even an explicit nil
func (o *DocumentSshConfigTrait) UnsetRemotePort() {
	o.RemotePort.Unset()
}

func (o DocumentSshConfigTrait) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o DocumentSshConfigTrait) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Host) {
		toSerialize["host"] = o.Host
	}
	if !IsNil(o.Port) {
		toSerialize["port"] = o.Port
	}
	if !IsNil(o.Username) {
		toSerialize["username"] = o.Username
	}
	if o.Password.IsSet() {
		toSerialize["password"] = o.Password.Get()
	}
	if o.CertificateId.IsSet() {
		toSerialize["certificateId"] = o.CertificateId.Get()
	}
	if o.RemoteHost.IsSet() {
		toSerialize["remoteHost"] = o.RemoteHost.Get()
	}
	if o.RemotePort.IsSet() {
		toSerialize["remotePort"] = o.RemotePort.Get()
	}
	return toSerialize, nil
}

type NullableDocumentSshConfigTrait struct {
	value *DocumentSshConfigTrait
	isSet bool
}

func (v NullableDocumentSshConfigTrait) Get() *DocumentSshConfigTrait {
	return v.value
}

func (v *NullableDocumentSshConfigTrait) Set(val *DocumentSshConfigTrait) {
	v.value = val
	v.isSet = true
}

func (v NullableDocumentSshConfigTrait) IsSet() bool {
	return v.isSet
}

func (v *NullableDocumentSshConfigTrait) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableDocumentSshConfigTrait(val *DocumentSshConfigTrait) *NullableDocumentSshConfigTrait {
	return &NullableDocumentSshConfigTrait{value: val, isSet: true}
}

func (v NullableDocumentSshConfigTrait) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableDocumentSshConfigTrait) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
